Index: /branches/HeuristicLab.TimeSeries/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/TimeSeriesPrognosis/TimeSeriesPrognosisSolutionBase.cs
===================================================================
--- /branches/HeuristicLab.TimeSeries/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/TimeSeriesPrognosis/TimeSeriesPrognosisSolutionBase.cs	(revision 7988)
+++ /branches/HeuristicLab.TimeSeries/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/TimeSeriesPrognosis/TimeSeriesPrognosisSolutionBase.cs	(revision 7989)
@@ -170,237 +167,145 @@
     protected TimeSeriesPrognosisSolutionBase(ITimeSeriesPrognosisModel model, ITimeSeriesPrognosisProblemData problemData)
       : base(model, problemData) {
-      Add(new Result(TrainingMeanSquaredErrorResultName, "Mean of squared errors of the model on the training partition", new DoubleArray()));
-      Add(new Result(TestMeanSquaredErrorResultName, "Mean of squared errors of the model on the test partition", new DoubleArray()));
-      Add(new Result(TrainingMeanAbsoluteErrorResultName, "Mean of absolute errors of the model on the training partition", new DoubleArray()));
-      Add(new Result(TestMeanAbsoluteErrorResultName, "Mean of absolute errors of the model on the test partition", new DoubleArray()));
-      Add(new Result(TrainingSquaredCorrelationResultName, "Squared Pearson's correlation coefficient of the model output and the actual values on the training partition", new DoubleArray()));
-      Add(new Result(TestSquaredCorrelationResultName, "Squared Pearson's correlation coefficient of the model output and the actual values on the test partition", new DoubleArray()));
-      Add(new Result(TrainingRelativeErrorResultName, "Average of the relative errors of the model output and the actual values on the training partition", new DoubleArray()));
-      Add(new Result(TestRelativeErrorResultName, "Average of the relative errors of the model output and the actual values on the test partition", new DoubleArray()));
-      Add(new Result(TrainingNormalizedMeanSquaredErrorResultName, "Normalized mean of squared errors of the model on the training partition", new DoubleArray()));
-      Add(new Result(TestNormalizedMeanSquaredErrorResultName, "Normalized mean of squared errors of the model on the test partition", new DoubleArray()));
-      Add(new Result(TrainingDirectionalSymmetryResultName, "The average directional symmetry of the forecasts of the model on the training partition", new DoubleArray()));
-      Add(new Result(TestDirectionalSymmetryResultName, "The average directional symmetry of the forecasts of the model on the test partition", new DoubleArray()));
-      Add(new Result(TrainingWeightedDirectionalSymmetryResultName, "The average weighted directional symmetry of the forecasts of the model on the training partition", new DoubleArray()));
-      Add(new Result(TestWeightedDirectionalSymmetryResultName, "The average weighted directional symmetry of the forecasts of the model on the test partition", new DoubleArray()));
-      Add(new Result(TrainingTheilsUStatisticLastResultName, "The average Theil's U statistic (reference: previous value) of the forecasts of the model on the training partition", new DoubleArray()));
-      Add(new Result(TestTheilsUStatisticLastResultName, "The average Theil's U statistic (reference: previous value) of the forecasts of the model on the test partition", new DoubleArray()));
-      Add(new Result(TrainingTheilsUStatisticMeanResultName, "The average Theil's U statistic (reference: mean value) of the forecasts of the model on the training partition", new DoubleArray()));
-      Add(new Result(TestTheilsUStatisticMeanResultName, "The average Theil's U statistic (reference: mean value) of the forecasts of the model on the test partition", new DoubleArray()));
-      Add(new Result(TrainingTheilsUStatisticMaResultName, "The average Theil's U statistic (reference: moving average) of the forecasts of the model on the training partition", new DoubleArray()));
-      Add(new Result(TestTheilsUStatisticMaResultName, "The average Theil's U statistic (reference: moving average) of the forecasts of the model on the test partition", new DoubleArray()));
+      Add(new Result(TrainingMeanSquaredErrorResultName, "Mean of squared errors of the model on the training partition", new DoubleValue()));
+      Add(new Result(TestMeanSquaredErrorResultName, "Mean of squared errors of the model on the test partition", new DoubleValue()));
+      Add(new Result(TrainingMeanAbsoluteErrorResultName, "Mean of absolute errors of the model on the training partition", new DoubleValue()));
+      Add(new Result(TestMeanAbsoluteErrorResultName, "Mean of absolute errors of the model on the test partition", new DoubleValue()));
+      Add(new Result(TrainingSquaredCorrelationResultName, "Squared Pearson's correlation coefficient of the model output and the actual values on the training partition", new DoubleValue()));
+      Add(new Result(TestSquaredCorrelationResultName, "Squared Pearson's correlation coefficient of the model output and the actual values on the test partition", new DoubleValue()));
+      Add(new Result(TrainingRelativeErrorResultName, "Average of the relative errors of the model output and the actual values on the training partition", new DoubleValue()));
+      Add(new Result(TestRelativeErrorResultName, "Average of the relative errors of the model output and the actual values on the test partition", new DoubleValue()));
+      Add(new Result(TrainingNormalizedMeanSquaredErrorResultName, "Normalized mean of squared errors of the model on the training partition", new DoubleValue()));
+      Add(new Result(TestNormalizedMeanSquaredErrorResultName, "Normalized mean of squared errors of the model on the test partition", new DoubleValue()));
+      Add(new Result(TrainingDirectionalSymmetryResultName, "The average directional symmetry of the forecasts of the model on the training partition", new DoubleValue()));
+      Add(new Result(TestDirectionalSymmetryResultName, "The average directional symmetry of the forecasts of the model on the test partition", new DoubleValue()));
+      Add(new Result(TrainingWeightedDirectionalSymmetryResultName, "The average weighted directional symmetry of the forecasts of the model on the training partition", new DoubleValue()));
+      Add(new Result(TestWeightedDirectionalSymmetryResultName, "The average weighted directional symmetry of the forecasts of the model on the test partition", new DoubleValue()));
+      Add(new Result(TrainingTheilsUStatisticLastResultName, "The average Theil's U statistic (reference: previous value) of the forecasts of the model on the training partition", new DoubleValue()));
+      Add(new Result(TestTheilsUStatisticLastResultName, "The average Theil's U statistic (reference: previous value) of the forecasts of the model on the test partition", new DoubleValue()));
+      Add(new Result(TrainingTheilsUStatisticMeanResultName, "The average Theil's U statistic (reference: mean value) of the forecasts of the model on the training partition", new DoubleValue()));
+      Add(new Result(TestTheilsUStatisticMeanResultName, "The average Theil's U statistic (reference: mean value) of the forecasts of the model on the test partition", new DoubleValue()));
+      Add(new Result(TrainingTheilsUStatisticMaResultName, "The average Theil's U statistic (reference: moving average) of the forecasts of the model on the training partition", new DoubleValue()));
+      Add(new Result(TestTheilsUStatisticMaResultName, "The average Theil's U statistic (reference: moving average) of the forecasts of the model on the test partition", new DoubleValue()));
       horizon = 1;
     }
 
-    [StorableHook(HookType.AfterDeserialization)]
-    private void AfterDeserialization() {
-      if (horizon == 0) horizon = 1;
-      bool anyNewResult = false;
-      if (!ContainsKey(TrainingTheilsUStatisticLastResultName)) {
-        Add(new Result(TrainingTheilsUStatisticLastResultName, "The average Theil's U statistic (reference: previous value) of the forecasts of the model on the training partition", new DoubleArray()));
-        anyNewResult = true;
-      }
-      if (!ContainsKey(TestTheilsUStatisticLastResultName)) {
-        Add(new Result(TestTheilsUStatisticLastResultName, "The average Theil's U statistic (reference: previous value) of the forecasts of the model on the test partition", new DoubleArray()));
-        anyNewResult = true;
-      }
-      if (!ContainsKey(TrainingTheilsUStatisticMeanResultName)) {
-        Add(new Result(TrainingTheilsUStatisticMeanResultName, "The average Theil's U statistic (reference: mean value) of the forecasts of the model on the training partition", new DoubleArray()));
-        anyNewResult = true;
-      }
-      if (!ContainsKey(TestTheilsUStatisticMeanResultName)) {
-        Add(new Result(TestTheilsUStatisticMeanResultName, "The average Theil's U statistic (reference: mean value) of the forecasts of the model on the test partition", new DoubleArray()));
-        anyNewResult = true;
-      }
-      if (!ContainsKey(TrainingTheilsUStatisticMaResultName)) {
-        Add(new Result(TrainingTheilsUStatisticMaResultName, "The average Theil's U statistic (reference: moving average) of the forecasts of the model on the training partition", new DoubleArray()));
-        anyNewResult = true;
-      }
-      if (!ContainsKey(TestTheilsUStatisticMaResultName)) {
-        Add(new Result(TestTheilsUStatisticMaResultName, "The average Theil's U statistic (reference: moving average) of the forecasts of the model on the test partition", new DoubleArray()));
-        anyNewResult = true;
-      }
-      if (anyNewResult)
-        RecalculateResults();
-    }
 
     protected void CalculateResults() {
-      string[] targetVariables = ProblemData.TargetVariables.ToArray();
-
-      var trainingMseCalculators = new OnlineMeanSquaredErrorCalculator[targetVariables.Length];
-      var testMseCalculators = new OnlineMeanSquaredErrorCalculator[targetVariables.Length];
-      var trainingMaeCalculators = new OnlineMeanAbsoluteErrorCalculator[targetVariables.Length];
-      var testMaeCalculators = new OnlineMeanAbsoluteErrorCalculator[targetVariables.Length];
-      var trainingRSquaredCalculators = new OnlinePearsonsRSquaredCalculator[targetVariables.Length];
-      var testRSquaredCalculators = new OnlinePearsonsRSquaredCalculator[targetVariables.Length];
-      var trainingRelErrorCalculators = new OnlineMeanAbsolutePercentageErrorCalculator[targetVariables.Length];
-      var testRelErrorCalculators = new OnlineMeanAbsolutePercentageErrorCalculator[targetVariables.Length];
-      var trainingNmseCalculators = new OnlineNormalizedMeanSquaredErrorCalculator[targetVariables.Length];
-      var testNmseCalculators = new OnlineNormalizedMeanSquaredErrorCalculator[targetVariables.Length];
-
-      var trainingDsCalculators = new OnlineDirectionalSymmetryCalculator[targetVariables.Length];
-      var testDsCalculators = new OnlineDirectionalSymmetryCalculator[targetVariables.Length];
-      var trainingWdsCalculators = new OnlineWeightedDirectionalSymmetryCalculator[targetVariables.Length];
-      var testWdsCalculators = new OnlineWeightedDirectionalSymmetryCalculator[targetVariables.Length];
-      var trainingTheilsULastCalculators = new OnlineTheilsUStatisticCalculator[targetVariables.Length];
-      var testTheilsULastCalculators = new OnlineTheilsUStatisticCalculator[targetVariables.Length];
-      var trainingTheilsUMeanCalculators = new OnlineTheilsUStatisticCalculator[targetVariables.Length];
-      var testTheilsUMeanCalculators = new OnlineTheilsUStatisticCalculator[targetVariables.Length];
-      var trainingTheilsUMovingAverageCalculators = new OnlineTheilsUStatisticCalculator[targetVariables.Length];
-      var testTheilsUMovingAverageCalculators = new OnlineTheilsUStatisticCalculator[targetVariables.Length];
-      for (int i = 0; i < targetVariables.Length; i++) {
-        trainingMseCalculators[i] = new OnlineMeanSquaredErrorCalculator();
-        testMseCalculators[i] = new OnlineMeanSquaredErrorCalculator();
-        trainingMaeCalculators[i] = new OnlineMeanAbsoluteErrorCalculator();
-        testMaeCalculators[i] = new OnlineMeanAbsoluteErrorCalculator();
-        trainingRSquaredCalculators[i] = new OnlinePearsonsRSquaredCalculator();
-        testRSquaredCalculators[i] = new OnlinePearsonsRSquaredCalculator();
-        trainingRelErrorCalculators[i] = new OnlineMeanAbsolutePercentageErrorCalculator();
-        testRelErrorCalculators[i] = new OnlineMeanAbsolutePercentageErrorCalculator();
-        trainingNmseCalculators[i] = new OnlineNormalizedMeanSquaredErrorCalculator();
-        testNmseCalculators[i] = new OnlineNormalizedMeanSquaredErrorCalculator();
-
-        trainingDsCalculators[i] = new OnlineDirectionalSymmetryCalculator();
-        testDsCalculators[i] = new OnlineDirectionalSymmetryCalculator();
-        trainingWdsCalculators[i] = new OnlineWeightedDirectionalSymmetryCalculator();
-        testWdsCalculators[i] = new OnlineWeightedDirectionalSymmetryCalculator();
-        trainingTheilsULastCalculators[i] = new OnlineTheilsUStatisticCalculator();
-        testTheilsULastCalculators[i] = new OnlineTheilsUStatisticCalculator();
-        trainingTheilsUMeanCalculators[i] = new OnlineTheilsUStatisticCalculator();
-        testTheilsUMeanCalculators[i] = new OnlineTheilsUStatisticCalculator();
-        trainingTheilsUMovingAverageCalculators[i] = new OnlineTheilsUStatisticCalculator();
-        testTheilsUMovingAverageCalculators[i] = new OnlineTheilsUStatisticCalculator();
-      }
-
-      var allPrognosedTrainingValues = GetPrognosedValues(ProblemData.TrainingIndizes, horizon).GetEnumerator();
-      double[] mean = new double[targetVariables.Length];
-      for (int t = 0; t < targetVariables.Length; t++) {
-        double variance;
-        OnlineCalculatorError meanErrorState, varErrorState;
-        OnlineMeanAndVarianceCalculator.Calculate(ProblemData.Dataset.GetDoubleValues(targetVariables[t], ProblemData.TrainingIndizes), out mean[t], out variance, out meanErrorState, out varErrorState);
-        if (meanErrorState != OnlineCalculatorError.None) mean[t] = 0.0;
-      }
+      string targetVariable = ProblemData.TargetVariable;
+
+      var trainingMseCalculators = new OnlineMeanSquaredErrorCalculator();
+      var testMseCalculators = new OnlineMeanSquaredErrorCalculator();
+      var trainingMaeCalculators = new OnlineMeanAbsoluteErrorCalculator();
+      var testMaeCalculators = new OnlineMeanAbsoluteErrorCalculator();
+      var trainingRSquaredCalculators = new OnlinePearsonsRSquaredCalculator();
+      var testRSquaredCalculators = new OnlinePearsonsRSquaredCalculator();
+      var trainingRelErrorCalculators = new OnlineMeanAbsolutePercentageErrorCalculator();
+      var testRelErrorCalculators = new OnlineMeanAbsolutePercentageErrorCalculator();
+      var trainingNmseCalculators = new OnlineNormalizedMeanSquaredErrorCalculator();
+      var testNmseCalculators = new OnlineNormalizedMeanSquaredErrorCalculator();
+
+      var trainingDsCalculators = new OnlineDirectionalSymmetryCalculator();
+      var testDsCalculators = new OnlineDirectionalSymmetryCalculator();
+      var trainingWdsCalculators = new OnlineWeightedDirectionalSymmetryCalculator();
+      var testWdsCalculators = new OnlineWeightedDirectionalSymmetryCalculator();
+      var trainingTheilsULastCalculators = new OnlineTheilsUStatisticCalculator();
+      var testTheilsULastCalculators = new OnlineTheilsUStatisticCalculator();
+      var trainingTheilsUMeanCalculators = new OnlineTheilsUStatisticCalculator();
+      var testTheilsUMeanCalculators = new OnlineTheilsUStatisticCalculator();
+      var trainingTheilsUMovingAverageCalculators = new OnlineTheilsUStatisticCalculator();
+      var testTheilsUMovingAverageCalculators = new OnlineTheilsUStatisticCalculator();
+
+      double mean = ProblemData.Dataset.GetDoubleValues(targetVariable, ProblemData.TrainingIndizes).Average();
+
       foreach (var row in ProblemData.TrainingIndizes) {
         if (row + horizon < ProblemData.Dataset.Rows) {
-          allPrognosedTrainingValues.MoveNext();
-          var prognosedTrainingValues = allPrognosedTrainingValues.Current.SelectMany(x => x.ToArray()).ToArray();
-          for (int t = 0; t < targetVariables.Length; t++) {
-            var actualContinuation = ProblemData.Dataset.GetDoubleValues(targetVariables[t],
-                                                                         Enumerable.Range(row, horizon));
-            int maWindow = 10 * horizon;
-            var movingAverageContinuation = from h in Enumerable.Range(0, horizon)
-                                            select (from r in Enumerable.Range(row + h - maWindow, maWindow - h)
-                                                    where r > 0
-                                                    select ProblemData.Dataset.GetDoubleValue(targetVariables[t], r)
-                                                   ).Average();
-            double startValue = ProblemData.Dataset.GetDoubleValue(targetVariables[t], row - 1);
-            var prognosedContinuation = prognosedTrainingValues.Skip(t).TakeEvery(targetVariables.Length);
-            trainingDsCalculators[t].Add(startValue, actualContinuation, prognosedContinuation);
-            trainingWdsCalculators[t].Add(startValue, actualContinuation, prognosedContinuation);
-            trainingTheilsULastCalculators[t].Add(startValue, actualContinuation, prognosedContinuation);
-            trainingTheilsUMeanCalculators[t].Add(startValue, actualContinuation.Select(x => mean[t]), actualContinuation, prognosedContinuation);
-            trainingTheilsUMovingAverageCalculators[t].Add(startValue, movingAverageContinuation, actualContinuation, prognosedContinuation);
-
-            var actualContinuationEnumerator = actualContinuation.GetEnumerator();
-            var prognosedContinuationEnumerator = prognosedContinuation.GetEnumerator();
-            while (actualContinuationEnumerator.MoveNext() & prognosedContinuationEnumerator.MoveNext()) {
-              trainingMseCalculators[t].Add(actualContinuationEnumerator.Current, prognosedContinuationEnumerator.Current);
-              trainingMaeCalculators[t].Add(actualContinuationEnumerator.Current, prognosedContinuationEnumerator.Current);
-              trainingRelErrorCalculators[t].Add(actualContinuationEnumerator.Current, prognosedContinuationEnumerator.Current);
-              trainingRSquaredCalculators[t].Add(actualContinuationEnumerator.Current, prognosedContinuationEnumerator.Current);
-              trainingNmseCalculators[t].Add(actualContinuationEnumerator.Current, prognosedContinuationEnumerator.Current);
-            }
-            if (actualContinuationEnumerator.MoveNext() | prognosedContinuationEnumerator.MoveNext())
-              throw new ArgumentException(
-                "Different number of elements in Actual continuation and prognosed continuation.");
+          var actualContinuation = ProblemData.Dataset.GetDoubleValues(targetVariable, Enumerable.Range(row, horizon)).ToList();
+          var prognosedContinuation = GetPrognosedValues(new List<int> { row }, horizon).First().ToList();
+
+          int maWindow = 10 * horizon;
+          var movingAverageContinuation = from h in Enumerable.Range(0, horizon)
+                                          select (from r in Enumerable.Range(row + h - maWindow, maWindow - h)
+                                                  where r > 0
+                                                  select ProblemData.Dataset.GetDoubleValue(targetVariable, r)
+                                                 ).Average();
+
+          double startValue = ProblemData.Dataset.GetDoubleValue(targetVariable, row - 1);
+
+          trainingDsCalculators.Add(startValue, actualContinuation, prognosedContinuation);
+          trainingWdsCalculators.Add(startValue, actualContinuation, prognosedContinuation);
+          trainingTheilsULastCalculators.Add(startValue, actualContinuation, prognosedContinuation);
+          trainingTheilsUMeanCalculators.Add(startValue, actualContinuation.Select(x => mean), actualContinuation, prognosedContinuation);
+          trainingTheilsUMovingAverageCalculators.Add(startValue, movingAverageContinuation, actualContinuation, prognosedContinuation);
+
+          var actualContinuationEnumerator = actualContinuation.GetEnumerator();
+          var prognosedContinuationEnumerator = prognosedContinuation.GetEnumerator();
+
+          while (actualContinuationEnumerator.MoveNext() & prognosedContinuationEnumerator.MoveNext()) {
+            trainingMseCalculators.Add(actualContinuationEnumerator.Current, prognosedContinuationEnumerator.Current);
+            trainingMaeCalculators.Add(actualContinuationEnumerator.Current, prognosedContinuationEnumerator.Current);
+            trainingRelErrorCalculators.Add(actualContinuationEnumerator.Current, prognosedContinuationEnumerator.Current);
+            trainingRSquaredCalculators.Add(actualContinuationEnumerator.Current, prognosedContinuationEnumerator.Current);
+            trainingNmseCalculators.Add(actualContinuationEnumerator.Current, prognosedContinuationEnumerator.Current);
           }
+          if (actualContinuationEnumerator.MoveNext() | prognosedContinuationEnumerator.MoveNext())
+            throw new ArgumentException("Different number of elements in Actual continuation and prognosed continuation.");
         }
       }
-      var allPrognosedTestValues = GetPrognosedValues(ProblemData.TestIndizes, horizon).ToArray().AsEnumerable().GetEnumerator();
+
+      mean = ProblemData.Dataset.GetDoubleValues(targetVariable, ProblemData.TestIndizes).Average();
       foreach (var row in ProblemData.TestIndizes) {
         if (row + horizon < ProblemData.Dataset.Rows) {
-          allPrognosedTestValues.MoveNext();
-          var prognosedTestValues = allPrognosedTestValues.Current.SelectMany(x => x);
-          for (int t = 0; t < targetVariables.Length; t++) {
-            var actualContinuation = ProblemData.Dataset.GetDoubleValues(targetVariables[t],
-                                                                         Enumerable.Range(row, horizon));
-            int maWindow = 10 * horizon;
-            var movingAverageContinuation = from h in Enumerable.Range(0, horizon)
-                                            select (from r in Enumerable.Range(row + h - maWindow, maWindow - h)
-                                                    where r > 0
-                                                    select ProblemData.Dataset.GetDoubleValue(targetVariables[t], r)
-                                                   ).Average();
-            double startValue = ProblemData.Dataset.GetDoubleValue(targetVariables[t], row - 1);
-            var prognosedContinuation = prognosedTestValues.Skip(t).TakeEvery(targetVariables.Length).ToArray();
-            testDsCalculators[t].Add(startValue, actualContinuation, prognosedContinuation);
-            testWdsCalculators[t].Add(startValue, actualContinuation, prognosedContinuation);
-            testTheilsULastCalculators[t].Add(startValue, actualContinuation, prognosedContinuation);
-            testTheilsUMeanCalculators[t].Add(startValue, actualContinuation.Select(x => mean[t]), actualContinuation, prognosedContinuation);
-            testTheilsUMovingAverageCalculators[t].Add(startValue, movingAverageContinuation, actualContinuation, prognosedContinuation);
-
-            var actualContinuationEnumerator = actualContinuation.GetEnumerator();
-            var prognosedContinuationEnumerator = prognosedContinuation.AsEnumerable().GetEnumerator();
-            while (actualContinuationEnumerator.MoveNext() & prognosedContinuationEnumerator.MoveNext()) {
-              testMseCalculators[t].Add(actualContinuationEnumerator.Current, prognosedContinuationEnumerator.Current);
-              testMaeCalculators[t].Add(actualContinuationEnumerator.Current, prognosedContinuationEnumerator.Current);
-              testRelErrorCalculators[t].Add(actualContinuationEnumerator.Current, prognosedContinuationEnumerator.Current);
-              testRSquaredCalculators[t].Add(actualContinuationEnumerator.Current, prognosedContinuationEnumerator.Current);
-              testNmseCalculators[t].Add(actualContinuationEnumerator.Current, prognosedContinuationEnumerator.Current);
-            }
-            if (actualContinuationEnumerator.MoveNext() | prognosedContinuationEnumerator.MoveNext())
-              throw new ArgumentException(
-                "Different number of elements in Actual continuation and prognosed continuation.");
+          var actualContinuation = ProblemData.Dataset.GetDoubleValues(targetVariable, Enumerable.Range(row, horizon)).ToList();
+          var prognosedContinuation = GetPrognosedValues(new List<int> { row }, horizon).First().ToList();
+
+          int maWindow = 10 * horizon;
+          var movingAverageContinuation = from h in Enumerable.Range(0, horizon)
+                                          select (from r in Enumerable.Range(row + h - maWindow, maWindow - h)
+                                                  where r > 0
+                                                  select ProblemData.Dataset.GetDoubleValue(targetVariable, r)
+                                                 ).Average();
+
+          double startValue = ProblemData.Dataset.GetDoubleValue(targetVariable, row - 1);
+          testDsCalculators.Add(startValue, actualContinuation, prognosedContinuation);
+          testWdsCalculators.Add(startValue, actualContinuation, prognosedContinuation);
+          testTheilsULastCalculators.Add(startValue, actualContinuation, prognosedContinuation);
+          testTheilsUMeanCalculators.Add(startValue, actualContinuation.Select(x => mean), actualContinuation, prognosedContinuation);
+          testTheilsUMovingAverageCalculators.Add(startValue, movingAverageContinuation, actualContinuation, prognosedContinuation);
+
+          var actualContinuationEnumerator = actualContinuation.GetEnumerator();
+          var prognosedContinuationEnumerator = prognosedContinuation.GetEnumerator();
+          while (actualContinuationEnumerator.MoveNext() & prognosedContinuationEnumerator.MoveNext()) {
+            testMseCalculators.Add(actualContinuationEnumerator.Current, prognosedContinuationEnumerator.Current);
+            testMaeCalculators.Add(actualContinuationEnumerator.Current, prognosedContinuationEnumerator.Current);
+            testRelErrorCalculators.Add(actualContinuationEnumerator.Current, prognosedContinuationEnumerator.Current);
+            testRSquaredCalculators.Add(actualContinuationEnumerator.Current, prognosedContinuationEnumerator.Current);
+            testNmseCalculators.Add(actualContinuationEnumerator.Current, prognosedContinuationEnumerator.Current);
           }
+          if (actualContinuationEnumerator.MoveNext() | prognosedContinuationEnumerator.MoveNext())
+            throw new ArgumentException("Different number of elements in Actual continuation and prognosed continuation.");
         }
       }
 
-
-      TrainingMeanSquaredError = trainingMseCalculators.Select(c => c.ErrorState == OnlineCalculatorError.None ? c.Value : double.PositiveInfinity)
-        .ToArray();
-      TestMeanSquaredError = testMseCalculators.Select(c => c.ErrorState == OnlineCalculatorError.None ? c.Value : double.PositiveInfinity)
-        .ToArray();
-      TrainingMeanAbsoluteError = trainingMaeCalculators.Select(c => c.ErrorState == OnlineCalculatorError.None ? c.Value : double.PositiveInfinity)
-        .ToArray();
-      TestMeanAbsoluteError = testMaeCalculators.Select(c => c.ErrorState == OnlineCalculatorError.None ? c.Value : double.PositiveInfinity)
-        .ToArray();
-      TrainingRelativeError = trainingRelErrorCalculators.Select(c => c.ErrorState == OnlineCalculatorError.None ? c.Value : double.PositiveInfinity)
-        .ToArray();
-      TestRelativeError = testRelErrorCalculators.Select(c => c.ErrorState == OnlineCalculatorError.None ? c.Value : double.PositiveInfinity)
-        .ToArray();
-      TrainingRSquared = trainingRSquaredCalculators.Select(c => c.ErrorState == OnlineCalculatorError.None ? c.Value : 0.0)
-        .ToArray();
-      TestRSquared = testRSquaredCalculators.Select(c => c.ErrorState == OnlineCalculatorError.None ? c.Value : 0.0)
-        .ToArray();
-      TrainingNormalizedMeanSquaredError = trainingNmseCalculators.Select(c => c.ErrorState == OnlineCalculatorError.None ? c.Value : double.PositiveInfinity)
-        .ToArray();
-      TestNormalizedMeanSquaredError = testNmseCalculators.Select(c => c.ErrorState == OnlineCalculatorError.None ? c.Value : double.PositiveInfinity)
-        .ToArray();
-
-      TrainingDirectionalSymmetry = trainingDsCalculators.Select(c => c.ErrorState == OnlineCalculatorError.None ? c.Value : 0.0)
-        .ToArray();
-      TestDirectionalSymmetry = testDsCalculators.Select(c => c.ErrorState == OnlineCalculatorError.None ? c.Value : 0.0)
-        .ToArray();
-      TrainingWeightedDirectionalSymmetry = trainingWdsCalculators.Select(c => c.ErrorState == OnlineCalculatorError.None ? c.Value : double.PositiveInfinity)
-        .ToArray();
-      TestWeightedDirectionalSymmetry = testWdsCalculators.Select(c => c.ErrorState == OnlineCalculatorError.None ? c.Value : double.PositiveInfinity)
-        .ToArray();
-      TrainingTheilsUStatisticLast = trainingTheilsULastCalculators
-        .Select(c => c.ErrorState == OnlineCalculatorError.None ? c.Value : double.PositiveInfinity)
-        .ToArray();
-      TestTheilsUStatisticLast = testTheilsULastCalculators
-        .Select(c => c.ErrorState == OnlineCalculatorError.None ? c.Value : double.PositiveInfinity)
-        .ToArray();
-      TrainingTheilsUStatisticMean = trainingTheilsUMeanCalculators
-        .Select(c => c.ErrorState == OnlineCalculatorError.None ? c.Value : double.PositiveInfinity)
-        .ToArray();
-      TestTheilsUStatisticMean = testTheilsUMeanCalculators
-        .Select(c => c.ErrorState == OnlineCalculatorError.None ? c.Value : double.PositiveInfinity)
-        .ToArray();
-      TrainingTheilsUStatisticMovingAverage = trainingTheilsUMovingAverageCalculators
-        .Select(c => c.ErrorState == OnlineCalculatorError.None ? c.Value : double.PositiveInfinity)
-        .ToArray();
-      TestTheilsUStatisticMovingAverage = testTheilsUMovingAverageCalculators
-        .Select(c => c.ErrorState == OnlineCalculatorError.None ? c.Value : double.PositiveInfinity)
-        .ToArray();
+      TrainingMeanSquaredError = trainingMseCalculators.ErrorState == OnlineCalculatorError.None ? trainingMseCalculators.Value : double.PositiveInfinity;
+      TestMeanSquaredError = testMseCalculators.ErrorState == OnlineCalculatorError.None ? testMseCalculators.Value : double.PositiveInfinity;
+      TrainingMeanAbsoluteError = trainingMaeCalculators.ErrorState == OnlineCalculatorError.None ? trainingMaeCalculators.Value : double.PositiveInfinity;
+      TestMeanAbsoluteError = testMaeCalculators.ErrorState == OnlineCalculatorError.None ? testMaeCalculators.Value : double.PositiveInfinity;
+      TrainingRelativeError = trainingRelErrorCalculators.ErrorState == OnlineCalculatorError.None ? trainingRelErrorCalculators.Value : double.PositiveInfinity;
+      TestRelativeError = testRelErrorCalculators.ErrorState == OnlineCalculatorError.None ? testRelErrorCalculators.Value : double.PositiveInfinity;
+      TrainingRSquared = trainingRSquaredCalculators.ErrorState == OnlineCalculatorError.None ? trainingRSquaredCalculators.Value : 0.0;
+      TestRSquared = testRSquaredCalculators.ErrorState == OnlineCalculatorError.None ? testRSquaredCalculators.Value : 0.0;
+      TrainingNormalizedMeanSquaredError = trainingNmseCalculators.ErrorState == OnlineCalculatorError.None ? trainingNmseCalculators.Value : double.PositiveInfinity;
+      TestNormalizedMeanSquaredError = testNmseCalculators.ErrorState == OnlineCalculatorError.None ? testNmseCalculators.Value : double.PositiveInfinity;
+
+      TrainingDirectionalSymmetry = trainingDsCalculators.ErrorState == OnlineCalculatorError.None ? trainingDsCalculators.Value : 0.0;
+      TestDirectionalSymmetry = testDsCalculators.ErrorState == OnlineCalculatorError.None ? testDsCalculators.Value : 0.0;
+      TrainingWeightedDirectionalSymmetry = trainingWdsCalculators.ErrorState == OnlineCalculatorError.None ? trainingWdsCalculators.Value : double.PositiveInfinity;
+      TestWeightedDirectionalSymmetry = testWdsCalculators.ErrorState == OnlineCalculatorError.None ? testWdsCalculators.Value : double.PositiveInfinity;
+      TrainingTheilsUStatisticLast = trainingTheilsULastCalculators.ErrorState == OnlineCalculatorError.None ? trainingTheilsULastCalculators.Value : double.PositiveInfinity;
+      TestTheilsUStatisticLast = testTheilsULastCalculators.ErrorState == OnlineCalculatorError.None ? testTheilsULastCalculators.Value : double.PositiveInfinity;
+      TrainingTheilsUStatisticMean = trainingTheilsUMeanCalculators.ErrorState == OnlineCalculatorError.None ? trainingTheilsUMeanCalculators.Value : double.PositiveInfinity;
+      TestTheilsUStatisticMean = testTheilsUMeanCalculators.ErrorState == OnlineCalculatorError.None ? testTheilsUMeanCalculators.Value : double.PositiveInfinity;
+      TrainingTheilsUStatisticMovingAverage = trainingTheilsUMovingAverageCalculators.ErrorState == OnlineCalculatorError.None ? trainingTheilsUMovingAverageCalculators.Value : double.PositiveInfinity;
+      TestTheilsUStatisticMovingAverage = testTheilsUMovingAverageCalculators.ErrorState == OnlineCalculatorError.None ? testTheilsUMovingAverageCalculators.Value : double.PositiveInfinity;
     }
   }
